#include "Common.ch"
#include "dll.ch"
#include "inkey.ch"
#include "Error.ch"



class MediaInfo

   PROTECTED

   var   nDllHandle


   EXPORTED

   var cVersionString, lError, cErrorText, nObjectHandle, nFileHandle, cResult

   method init, destroy, open, close, peekstring, videoformat, audioformat, fullInfo, isVideo, isAudio, artist, lange
   method genere,year,titel,titel2,track,tracktotal,album,bitrate
   method GetallusedParms

endclass


method MediaInfo:init()

    ::lError     := .f.
    ::cErrorText := ""
    ::nFileHandle   := 0
    ::nObjectHandle := 0
    ::cResult := nil

    ::nDllHandle := DllLoad("mediainfo_i386.dll")
       
    if ::nDllHandle = 0 
       ::lerror := .t.
       ::cErrorText += "Fehler: DLL  'mediainfo_i386.dll' nicht gefunden. / "
    else
        DllCall(::nDllHandle,DLL_STDCALL,"MediaInfoA_Option", 0, "Internet", "No"   )

        nX:=DllCall(::nDllHandle,DLL_STDCALL, "MediaInfoA_Option", 0, "Info_Version", "" )
        ::cVersionString := ::peekString( DllCall(::nDllHandle,DLL_STDCALL, "MediaInfoA_Option", 0, "Info_Version", ""   ) )

        if !"v19.09" $ ::cVersionString
          ::lerror := .t.
          ::cErrorText += "Version unpassend / " + ::cVersionString + " / "
       endif
   endif

return(self)


method MediaInfo:destroy()
    ::close()
    dllunLoad( ::nDllHandle )
return(self)


method MediaInfo:open( cFname )
    ::close()
    ::lError     := .f.
    ::cErrorText := ""
    cFname := alltrim(cFname)
    ::nObjectHandle := DllCall(::nDllHandle,DLL_STDCALL,"MediaInfoA_New" )
    ::nFileHandle   := DllCall(::nDllHandle,DLL_STDCALL,"MediaInfoA_Open", ::nObjectHandle, cFname+chr(0) )

    if ::nFileHandle = 0
       ::lerror := .t.
       ::cErrorText += "Zugriff auf File nicht mglich: " + cFname + " / "
    endif
return(self)




method MediaInfo:close()
    if ::nFileHandle != 0
       DllCall(::nDllHandle,DLL_STDCALL,"MediaInfoA_Close", ::nObjectHandle )
       ::nFileHandle := 0
    endif
    if ::nObjectHandle != 0
       DllCall(::nDllHandle,DLL_STDCALL,"MediaInfoA_Delete", ::nObjectHandle  )
       ::nObjectHandle := 0
    endif
return(self)

method MediaInfo:peekString(nAddress)
   local cOut :="", nX := nAddress, nY := PeekByte(nX)
   do while nY!=0
      cOut+=chr(nY)
      nX++
      nY:=PeekByte(nX)
   enddo
return( cOut )


method MediaInfo:fullInfo()
    cResult := ::peekString( DllCall(::nDllHandle,DLL_STDCALL,"MediaInfoA_Inform", ::nObjectHandle ) )
return(cResult)

method MediaInfo:isVideo()
    ::cResult := ::peekString(DllCall(::nDllHandle,DLL_STDCALL,"MediaInfoA_Get", ::nObjectHandle, 0, 0, 'VideoCount', 1, 0) )
return( val(::cResult)>0 )

method MediaInfo:isAudio()
    ::cResult := ::peekString(DllCall(::nDllHandle,DLL_STDCALL,"MediaInfoA_Get", ::nObjectHandle, 0, 0, 'AudioCount', 1, 0) )
return( val(::cResult)>0.and.!::isVideo() )


method MediaInfo:artist()
    ::cResult := ::peekString(DllCall(::nDllHandle,DLL_STDCALL,"MediaInfoA_Get", ::nObjectHandle, 0, 0, 'Performer', 1, 0) )
return(::cResult)


method MediaInfo:Audioformat()
    ::cResult := ::peekString(DllCall(::nDllHandle,DLL_STDCALL,"MediaInfoA_Get", ::nObjectHandle, 0, 0, 'Audio_Format_List', 1, 0) )
    do case
        case "AAC" $ ::cResult
            ::cResult := "m4a"
        case "MPEG Audio" $ ::cResult
            ::cResult := "mp3"
    endcase
    ::cResult := lower( ::cResult )
return(::cResult)

method MediaInfo:Videoformat()
    ::cResult := ::peekString(DllCall(::nDllHandle,DLL_STDCALL,"MediaInfoA_Get", ::nObjectHandle, 0, 0, 'Video_Format_List', 1, 0) )
    ::cResult := lower( ::cResult )
return(::cResult)

method MediaInfo:lange()
    ::cResult := ::peekString(DllCall(::nDllHandle,DLL_STDCALL,"MediaInfoA_Get", ::nObjectHandle, 0, 0, 'Duration/String3', 1, 0) )
return(left(::cResult,8))

method MediaInfo:genere()
    ::cResult := ::peekString(DllCall(::nDllHandle,DLL_STDCALL,"MediaInfoA_Get", ::nObjectHandle, 0, 0, 'Genre', 1, 0) )
return(charrem("[]", ::cResult) )

method MediaInfo:year()
    ::cResult := ::peekString(DllCall(::nDllHandle,DLL_STDCALL,"MediaInfoA_Get", ::nObjectHandle, 0, 0, 'Recorded_Date', 1, 0) )
return(::cResult)

method MediaInfo:titel()
    ::cResult := ::peekString(DllCall(::nDllHandle,DLL_STDCALL,"MediaInfoA_Get", ::nObjectHandle, 0, 0, 'Title', 1, 0) )
return(::cResult)

method MediaInfo:titel2()
local a := val( ::track() )
    ::cResult := ntoc(a,10, iif(a<100,2,3),"0")+" - " + ::titel()
return(::cResult)

method MediaInfo:track()
    ::cResult := ::peekString(DllCall(::nDllHandle,DLL_STDCALL,"MediaInfoA_Get", ::nObjectHandle, 0, 0, 'Track/Position', 1, 0) )
return(::cResult)

method MediaInfo:tracktotal()
    ::cResult := ::peekString(DllCall(::nDllHandle,DLL_STDCALL,"MediaInfoA_Get", ::nObjectHandle, 0, 0, 'Track/Position_Total', 1, 0) )
return(::cResult)

method MediaInfo:album()
    ::cResult := ::peekString(DllCall(::nDllHandle,DLL_STDCALL,"MediaInfoA_Get", ::nObjectHandle, 0, 0, 'Album', 1, 0) )
return(::cResult)

method MediaInfo:bitrate()
    ::cResult := ::peekString(DllCall(::nDllHandle,DLL_STDCALL,"MediaInfoA_Get", ::nObjectHandle, 0, 0, 'BitRate/String', 1, 0) )
return(token(::cResult," ",1))

method MediaInfo:GetallusedParms()
local t, t1, t2, t3, a, x
    ::cResult := ""

    t := ::peekString( DllCall(::nDllHandle,DLL_STDCALL, "MediaInfoA_Option", 0, "Info_Parameters", "") )
    t1  := ""
    arr := {}
    for a = 1 to numtoken(t,chr(10))
         t1 := token(t,chr(10),a)
         if ":"  $ t1
             t3 := alltrim(charrem(chr(13),token(t1,":",2)))
             t1 := alltrim(token(t1,":",1))
             if !empty(t1)
                if ascan(arr,{|x|x==t1}) = 0
                    aadd(arr, t1 )
                    t2 :=  ::peekString(DllCall(::nDllHandle,DLL_STDCALL,"MediaInfoA_Get", ::nObjectHandle, 0, 0, t1, 1, 0) )
                    if !empty(t2)
                        ::cResult += padr(t1,30) + padr(t2, iif(len(t2)<40,40,len(t2)+10))+ t3 + crlf
                    endif
                endif
             endif
         endif
    next

return(::cResult )


